#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


int main()
{
    long long t,n,m,a,b,x;
    vector<long long>godine;
    vector<long long>odbijene;
    cin >> t;
    int br;
    vector<int>resenje;
    for(long long i=0;i<t;i++)
    {
        cin >> n >> m;
        for(long long j=0;j<n;j++)
        {
            cin >> a;
            godine.push_back(a);
        }
        sort(godine.begin(),godine.end());
        for(long long o=0;o<m;o++)
        {
            cin >> b;
            odbijene.push_back(b);
        }
        sort(odbijene.begin(),odbijene.end());
        x=godine[1]-godine[0];
        for(long long q=2;q!=godine.size();q++)
        {
            x=min(x,(godine[q]-godine[q-1]));
        }
        for(long long k=1;k<godine.size();k++)
        {
            if((godine[k]-godine[k-1])%x==0)
                br=1;
            else
            {
                br=0;
                break;
            }
        }
        if(br==1)
        {
            for(long long l=0;l<odbijene.size();l++)
        {
            if(abs(godine[0]-odbijene[l])%x!=0)
                br=1;
            else
            {
                br=0;
                break;
            }
        }
        }
        resenje.push_back(br);
        godine.clear();
        odbijene.clear();
    }
    for(long long h=0;h<resenje.size();h++)
        cout << resenje[h] << "\n";
    
    return 0;
}